<?php
define('TEST_RUN', 1);

// Nacoma depends on Ninja making its classes available, and its autoloader in
// general
define('SKIP_KOHANA', true);
require('/opt/monitor/op5/ninja/index.php');

// These two evil methods can be called from something like setUpBeforeClass/tearDownAfterClass:
// They both configure globals in nacoma, and sets up a nagios instance for the tests to use.

function evil_global_setup()
{
	assert(false !== getenv('WORK_DIR'));
	assert(false !== system('mkdir -p '.getenv('WORK_DIR')));
	$workdir = realpath(getenv('WORK_DIR'));
	assert(false !== system('cp -r test/unit/configs/* '.$workdir));
	assert(false !== system('sed -e "s|@@PWD@@|'.$workdir.'|g" -e "s|@@USER@@|$(id -un)|" -e "s|@@GROUP@@|$(id -gn)|" test/unit/configs/nagios.cfg.in > '.$workdir.'/nagios.cfg'));
	assert(false !== system('sed -e "s|@@PWD@@|'.$workdir.'|" test/unit/configs/yml/livestatus.yml.in > '.$workdir.'/yml/livestatus.yml'));
	assert(false !== system('mkdir -m 0777 -p '.$workdir.'/var/rw'));
	require_once('include/config.inc.php');
	global $DEBUG;
	$DEBUG = TRUE;
	global $HOME;
	$HOME = $workdir . '/';
	global $Config;
	$Config["main"] = $HOME."nagios.cfg";
	$Config["cgi"] = $HOME."cgi.cfg";
	assert(false !== system('chmod -R 0777 '.$workdir));
	$out = system('asmonitor naemon -d '.$workdir.'/nagios.cfg');
	assert(false !== $out);
	$reasonable = 100;
	while ($reasonable-- && (!file_exists($workdir.'/var/nagios.lock') || !file_exists($workdir.'/var/rw/live'))) {
		usleep(100000);
	}
	assert((bool)$reasonable);
}

function evil_global_teardown()
{
	assert(false !== getenv('WORK_DIR'));
	$workdir = realpath(getenv('WORK_DIR'));
	if (file_exists($workdir.'/var/nagios.lock'))
		assert(false !== system('asmonitor kill -s SIGTERM $(cat '.$workdir.'/var/nagios.lock)'));
	$reasonable = 100;
	while ($reasonable-- && (file_exists($workdir.'/var/nagios.lock') || file_exists($workdir.'/var/rw/live'))) {
		usleep(100000);
	}
	assert((bool)$reasonable);
}
